Name:		hp-ixgbevf
Version:	4.0.5
Release:	1.%{distro}
Group:		System/Kernel
Vendor:		Intel Corporation
URL:		http://www.intel.com/network/connectivity/products/server_adapters.htm
Packager:	Hewlett-Packard Enterprise Company
License:	GPL
Source0:	%{name}-%{version}.tar.gz
Source1:        %{name}.files
BuildRoot:	%{_tmppath}/%{name}-%{version}-build
Summary:	Intel(R) 10GbE PCI Express Ethernet Kernel Module for HP ProLiant systems ixgbevf Driver for Linux

%define debug_package %{nil}

%if "%{_vendor}" == "suse"
%if %{!?KVER:1}%{?KVER:0}
%ifarch x86_64
%define flav default kdump smp xen
%else
%define flav default bigsmp kdump kdumpae smp xen xenpae pae
%endif
%endif

%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"-" '{print $3}')
%endif
%endif

%if "%{_vendor}" == "redhat"
%if %{!?KVER:1}%{?KVER:0}
%define flav ""
%endif
%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"el5" '{print $2}')
%if "%{flav}" == ""
%define flav default
%endif
%endif
%endif

%if "%{_vendor}" == "suse"
%if 0%{?suse_version} >= 1315
BuildRequires: kernel-syms
%else
BuildRequires: kernel-source kernel-syms
%endif
%define install_mod_dir updates/%{name}
%define kernel_source /usr/src/linux-obj/%{_target_cpu}
%{suse_kernel_module_package -x %flav}
%else
BuildRequires: %kernel_module_package_buildreqs
%define install_mod_dir extra/%{name}
%{kernel_module_package -f %{SOURCE1} %flav}
%endif

%description
Intel(R) 10GbE PCI Express Ethernet Kernel Module for HP ProLiant systems ixgbevf Driver for Linux
SRPMS available at http://downloads.linux.hpe.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hpe.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package KMP
Summary: Intel(R) 10GbE PCI Express Ethernet Kernel Module for HP ProLiant systems ixgbevf Driver for Linux
Group: System/Kernel

%description KMP
Intel(R) 10GbE PCI Express Ethernet Kernel Module for HP ProLiant systems ixgbevf Driver for Linux
SRPMS available at http://downloads.linux.hpe.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hpe.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package doc
Summary: Documentation for the %{name} kernel module
Group: System/Kernel
%if "%{_vendor}" == "redhat"
Requires: %{name}-kmod = %{version}-%{release}
%else
Requires: %{name}-kmp
%endif

%description doc
Documentation for the Intel(R) 10GbE PCI Express Ethernet Kernel Module for HP ProLiant systems ixgbevf Driver for Linux

%prep
%setup
set -- *
mkdir source
mv "$@" source/
mkdir obj
echo "override ixgbevf * weak-updates/%{name}" > %{name}.conf

%build
export EXTRA_CFLAGS='-DVERSION="%version"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	rm -rf obj/$flavor
	cp -r source obj/$flavor
	make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor}

	#mark modules executable so that strip-to-file can strip them
	find obj/$flavor/ -name "*.ko" -type f -exec chmod u+x '{}' +
done
gzip < source/ixgbevf.7 > source/ixgbevf.7.gz

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor} install
	#Cleanup unnecessary kernel-generated module dependency files.
	find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;
done
install -D -m 644 source/ixgbevf.7.gz $RPM_BUILD_ROOT/%{_mandir}/man7/ixgbevf.7.gz
install -d %{buildroot}%{_sysconfdir}/depmod.d/
install %{name}.conf %{buildroot}%{_sysconfdir}/depmod.d/

%define _unpackaged_files_terminate_build 0

%postun doc
if [ -f %{_mandir}/man7/ixgbevf.7.gz ]; then
	exit 0
fi

%clean
rm -rf %{buildroot}

%files
%{_sysconfdir}/depmod.d/%{name}.conf

%files doc
%defattr(-, root, root)
%{_mandir}/man7/ixgbevf.7.gz
%doc source/COPYING source/README

%changelog
* Mon Mar 13 2017 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> %version-%release
- Added SLES12SP2 support
- Added RHEL 7.3 support
- Fixed the issue of installing ixgbevf corrupts ability of virtual machine to boot from SLES 11 SP4

* Tue Jun 21 2016 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 3.2.2-1
- Added RHEL 6.8 support
- Fix the issue of setting of invalid MTU
- Added support for ethtool RSS get/set functionality
- Fix the issue of No error generated if untrusted VM user tries to set user defined VF MAC address

* Wed Apr 13 2016 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 3.1.2-2
 - Fix the issue of packet loss in Virtual Functions(VF) in cases where Physical Function(PF) interface is brought up after VF.
 - Added support for Multicast promiscous mode for trusted Virtual Functions

* Tue Nov 10 2015 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 2.16.4-6
 - Added SLES12SP1 support
 - Added RHEL 7.2 support

* Tue Jul 07 2015 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 2.16.1-12
 - Added SLES11SP4 support
 - Added RHEL 6.7 support

* Tue Mar 17 2015 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 2.16.1-3
 - Added RHEL 7.1 support

* Wed Nov 12 2014 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 2.16.0.43
 - Added SLES 12 support
 - Added RHEL 6.6 support
 - Added netconsole/netpoll support for Virtual Function interface
 - Fixed vlan support issues on linux kernels >= 3.10 which was broken due to recent kernel changes
 - Fixed issue of ifconfig TX stats incrementing without traffic present on VF interface
 - Fixes the issue of TX Unit hang which occurs when re-plugging of  network cable while passing traffic on VMs(using VFs)

* Wed May 21 2014 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 2.12.0.38-10

* Wed Nov 27 2013 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 2.12.0.38-4
 - Fixed the issue of SLES 11 SP2 VM guest unable to change hardware offload settings for VF interface
 - Correct support for NDO features in VF
 - Correct build if HAVE_LVAN_RX_REGISTER not defined
 - Fixed the driver hang issue when rmmod is done on RHEL 5.9 Guest opearting systems
 - Support for bus poll sockets

* Mon Jul 15 2013 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 2.10.0.11-5
  - Initial release of the SRIOV virtual function driver
